commit:     fd32d95f547b668b9d8fdddf36b35ce35a7edc77
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sun Dec 20 21:12:42 2015 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sun Dec 20 21:13:24 2015 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=fd32d95f

dev-python/pypy3: Add a live ebuild

 dev-python/pypy3/files/2.5.0-shared-lib.patch  |  12 ++
 dev-python/pypy3/files/4.0.0-gentoo-path.patch |  50 ++++++
 dev-python/pypy3/pypy3-9999.ebuild             | 233 +++++++++++++++++++++++++
 3 files changed, 295 insertions(+)

diff --git a/dev-python/pypy3/files/2.5.0-shared-lib.patch 
b/dev-python/pypy3/files/2.5.0-shared-lib.patch
new file mode 100644
index 0000000..ddd7473
--- /dev/null
+++ b/dev-python/pypy3/files/2.5.0-shared-lib.patch
@@ -0,0 +1,12 @@
+diff -ur pypy-2.5.0-src.orig/rpython/translator/platform/posix.py 
pypy-2.5.0-src/rpython/translator/platform/posix.py
+--- rpython/translator/platform/posix.py       2015-02-03 05:12:49.000000000 
+0800
++++ rpython/translator/platform/posix.py       2015-03-22 07:36:01.420116684 
+0800
+@@ -183,7 +183,7 @@
+                    'int main(int argc, char* argv[]) '
+                    '{ return $(PYPY_MAIN_FUNCTION)(argc, argv); }" > $@')
+             m.rule('$(DEFAULT_TARGET)', ['$(TARGET)', 'main.o'],
+-                   '$(CC_LINK) $(LDFLAGS_LINK) main.o -L. 
-l$(SHARED_IMPORT_LIB) -o $@ $(RPATH_FLAGS)')
++                   '$(CC_LINK) $(LDFLAGS_LINK) main.o -L. 
-l$(SHARED_IMPORT_LIB) \'-Wl,-rpath,$$ORIGIN\' -o $@')
+ 
+         return m
+ 

diff --git a/dev-python/pypy3/files/4.0.0-gentoo-path.patch 
b/dev-python/pypy3/files/4.0.0-gentoo-path.patch
new file mode 100644
index 0000000..1c0270d
--- /dev/null
+++ b/dev-python/pypy3/files/4.0.0-gentoo-path.patch
@@ -0,0 +1,50 @@
+From 165e05bbdc93e54411217c0198d0a5cbb9de4e33 Mon Sep 17 00:00:00 2001
+From: =?UTF-8?q?Micha=C5=82=20G=C3=B3rny?= <[email protected]>
+Date: Fri, 27 Nov 2015 17:02:42 +0100
+Subject: [PATCH] Gentoo: override paths for system-wide install based on
+ sys.prefix
+
+Override all default distutils install paths to ones suitable for
+system-wide install when sys.prefix indicates we're running the Gentoo
+system-wide install of PyPy with no prefix overrides (e.g. virtualenv).
+
+Fixes: https://bugs.gentoo.org/462306
+Fixes: https://bugs.gentoo.org/465546
+---
+ lib-python/3/distutils/command/install.py | 13 ++++++++++++-
+ 1 file changed, 12 insertions(+), 1 deletion(-)
+
+diff --git a/lib-python/3/distutils/command/install.py 
b/lib-python/3/distutils/command/install.py
+index fc43951..fed5218 100644
+--- a/lib-python/3/distutils/command/install.py
++++ b/lib-python/3/distutils/command/install.py
+@@ -90,6 +90,13 @@ INSTALL_SCHEMES = {
+         'scripts': '$base/bin',
+         'data'   : '$base',
+         },
++    'gentoo': {
++        'purelib': '$base/site-packages',
++        'platlib': '$base/site-packages',
++        'headers': '$base/include',
++        'scripts': '@EPREFIX@/usr/bin',
++        'data'   : '@EPREFIX@/usr',
++        },
+     }
+ 
+ # The keys to an installation scheme; if any new types of files are to be
+@@ -476,7 +483,11 @@ class install (Command):
+         # it's the caller's problem if they supply a bad name!
+         if (hasattr(sys, 'pypy_version_info') and
+             not name.endswith(('_user', '_home'))):
+-            name = 'pypy'
++            if self.install_base == 
os.path.normpath('@EPREFIX@/usr/@libdir@/pypy'):
++                # override paths for system-wide install
++                name = 'gentoo'
++            else:
++                name = 'pypy'
+         scheme = INSTALL_SCHEMES[name]
+         for key in SCHEME_KEYS:
+             attrname = 'install_' + key
+-- 
+2.6.3
+

diff --git a/dev-python/pypy3/pypy3-9999.ebuild 
b/dev-python/pypy3/pypy3-9999.ebuild
new file mode 100644
index 0000000..a335b0f
--- /dev/null
+++ b/dev-python/pypy3/pypy3-9999.ebuild
@@ -0,0 +1,233 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+# pypy3 needs to be built using python 2
+PYTHON_COMPAT=( python2_7 pypy )
+EHG_PROJECT="pypy"
+EHG_REPO_URI="https://bitbucket.org/pypy/pypy";
+EHG_REVISION="py3k"
+inherit check-reqs eutils mercurial multilib multiprocessing pax-utils 
python-any-r1 toolchain-funcs versionator
+
+DESCRIPTION="A fast, compliant alternative implementation of the Python 
language"
+HOMEPAGE="http://pypy.org/";
+SRC_URI=""
+
+LICENSE="MIT"
+SLOT="0/$(get_version_component_range 1-2 ${PV})"
+KEYWORDS=""
+IUSE="bzip2 gdbm +jit low-memory ncurses sandbox shadowstack sqlite 
cpu_flags_x86_sse2 test tk"
+
+RDEPEND=">=sys-libs/zlib-1.1.3:0=
+       virtual/libffi:0=
+       virtual/libintl:0=
+       dev-libs/expat:0=
+       dev-libs/openssl:0=[-bindist]
+       bzip2? ( app-arch/bzip2:0= )
+       gdbm? ( sys-libs/gdbm:0= )
+       ncurses? ( sys-libs/ncurses:0= )
+       sqlite? ( dev-db/sqlite:3= )
+       tk? (
+               dev-lang/tk:0=
+               dev-tcltk/tix:0=
+       )
+       !dev-python/pypy3-bin:0"
+DEPEND="${RDEPEND}
+       low-memory? ( virtual/pypy:0 )
+       !low-memory? ( ${PYTHON_DEPS} )"
+PDEPEND="app-admin/python-updater"
+
+S="${WORKDIR}/${P}-src"
+
+pkg_pretend() {
+       if [[ ${MERGE_TYPE} != binary ]]; then
+               if use low-memory; then
+                       CHECKREQS_MEMORY="1750M"
+                       use amd64 && CHECKREQS_MEMORY="3500M"
+               else
+                       CHECKREQS_MEMORY="3G"
+                       use amd64 && CHECKREQS_MEMORY="6G"
+               fi
+
+               check-reqs_pkg_pretend
+       fi
+}
+
+pkg_setup() {
+       if [[ ${MERGE_TYPE} != binary ]]; then
+               pkg_pretend
+
+               # unset to allow forcing pypy below :)
+               use low-memory && local EPYTHON=
+               if python_is_installed pypy && [[ ! ${EPYTHON} || ${EPYTHON} == 
pypy ]]; then
+                       einfo "Using PyPy to perform the translation."
+                       local EPYTHON=pypy
+               else
+                       einfo "Using ${EPYTHON:-python2} to perform the 
translation. Please note that upstream"
+                       einfo "recommends using PyPy for that. If you wish to 
do so, please install"
+                       einfo "virtual/pypy and ensure that EPYTHON variable is 
unset."
+               fi
+
+               python-any-r1_pkg_setup
+       fi
+}
+
+src_unpack() {
+       default
+       mercurial_src_unpack
+}
+
+src_prepare() {
+       epatch "${FILESDIR}/4.0.0-gentoo-path.patch" \
+               
"${FILESDIR}/1.9-distutils.unixccompiler.UnixCCompiler.runtime_library_dir_option.patch"
 \
+               "${FILESDIR}"/2.5.0-shared-lib.patch    # 517002
+
+       sed -e "s^@EPREFIX@^${EPREFIX}^" \
+               -e "s^@libdir@^$(get_libdir)^" \
+               -i lib-python/3/distutils/command/install.py || die
+
+       epatch_user
+}
+
+src_compile() {
+       tc-export CC
+
+       local jit_backend
+       if use jit; then
+               jit_backend='--jit-backend='
+
+               # We only need the explicit sse2 switch for x86.
+               # On other arches we can rely on autodetection which uses
+               # compiler macros. Plus, --jit-backend= doesn't accept all
+               # the modern values...
+
+               if use x86; then
+                       if use cpu_flags_x86_sse2; then
+                               jit_backend+=x86
+                       else
+                               jit_backend+=x86-without-sse2
+                       fi
+               else
+                       jit_backend+=auto
+               fi
+       fi
+
+       local args=(
+               --shared
+               $(usex jit -Ojit -O2)
+               $(usex shadowstack --gcrootfinder=shadowstack '')
+               $(usex sandbox --sandbox '')
+
+               ${jit_backend}
+               --make-jobs=$(makeopts_jobs)
+
+               pypy/goal/targetpypystandalone
+       )
+
+       # Avoid linking against libraries disabled by use flags
+       local opts=(
+               bzip2:bz2
+               ncurses:_minimal_curses
+       )
+
+       local opt
+       for opt in "${opts[@]}"; do
+               local flag=${opt%:*}
+               local mod=${opt#*:}
+
+               args+=(
+                       $(usex ${flag} --withmod --withoutmod)-${mod}
+               )
+       done
+
+       local interp=( "${PYTHON}" )
+       if use low-memory; then
+               interp=( env PYPY_GC_MAX_DELTA=200MB
+                       "${PYTHON}" --jit loop_longevity=300 )
+       fi
+
+       set -- "${interp[@]}" rpython/bin/rpython --batch "${args[@]}"
+       echo -e "\033[1m${@}\033[0m"
+       "${@}" || die "compile error"
+
+       #use doc && emake -C pypy/doc/ html
+       pax-mark m "${ED%/}${INSDESTTREE}/pypy-c"
+}
+
+src_install() {
+       einfo "Installing PyPy ..."
+       insinto "/usr/$(get_libdir)/pypy3"
+       doins -r include lib_pypy lib-python pypy-c libpypy-c.so
+       fperms a+x ${INSDESTTREE}/pypy-c ${INSDESTTREE}/libpypy-c.so
+       pax-mark m "${ED%/}${INSDESTTREE}/pypy-c" 
"${ED%/}${INSDESTTREE}/libpypy-c.so"
+       dosym ../$(get_libdir)/pypy3/pypy-c /usr/bin/pypy3
+       dodoc README.rst
+
+       if ! use gdbm; then
+               rm -r "${ED%/}${INSDESTTREE}"/lib_pypy/gdbm.py \
+                       "${ED%/}${INSDESTTREE}"/lib-python/*3/test/test_gdbm.py 
|| die
+       fi
+       if ! use sqlite; then
+               rm -r "${ED%/}${INSDESTTREE}"/lib-python/*3/sqlite3 \
+                       "${ED%/}${INSDESTTREE}"/lib_pypy/_sqlite3.py \
+                       
"${ED%/}${INSDESTTREE}"/lib-python/*3/test/test_sqlite.py || die
+       fi
+       if ! use tk; then
+               rm -r "${ED%/}${INSDESTTREE}"/lib-python/*3/{idlelib,tkinter} \
+                       "${ED%/}${INSDESTTREE}"/lib_pypy/_tkinter \
+                       
"${ED%/}${INSDESTTREE}"/lib-python/*3/test/test_{tcl,tk,ttk*}.py || die
+       fi
+
+       # Install docs
+       #use doc && dohtml -r pypy/doc/_build/html/
+
+       einfo "Generating caches and byte-compiling ..."
+
+       local -x PYTHON=${ED%/}${INSDESTTREE}/pypy-c
+       local -x LD_LIBRARY_PATH="${ED%/}${INSDESTTREE}"
+       # we can't use eclass function since PyPy is dumb and always gives
+       # paths relative to the interpreter
+       local PYTHON_SITEDIR=${EPREFIX}/usr/$(get_libdir)/pypy3/site-packages
+       python_export pypy3 EPYTHON
+
+       echo "EPYTHON='${EPYTHON}'" > epython.py || die
+       python_domodule epython.py
+
+       # Generate Grammar and PatternGrammar pickles.
+       "${PYTHON}" -c "import lib2to3.pygram, lib2to3.patcomp; 
lib2to3.patcomp.PatternCompiler()" \
+               || die "Generation of Grammar and PatternGrammar pickles failed"
+
+       # Generate cffi modules
+       # Please keep in sync with pypy/tool/build_cffi_imports.py!
+#cffi_build_scripts = {
+#    "sqlite3": "_sqlite3_build.py",
+#    "audioop": "_audioop_build.py",
+#    "tk": "_tkinter/tklib_build.py",
+#    "curses": "_curses_build.py" if sys.platform != "win32" else None,
+#    "syslog": "_syslog_build.py" if sys.platform != "win32" else None,
+#    "gdbm": "_gdbm_build.py"  if sys.platform != "win32" else None,
+#    "pwdgrp": "_pwdgrp_build.py" if sys.platform != "win32" else None,
+       cffi_targets=( audioop syslog pwdgrp )
+       use gdbm && cffi_targets+=( gdbm )
+       use ncurses && cffi_targets+=( curses )
+       use sqlite && cffi_targets+=( sqlite3 )
+       use tk && cffi_targets+=( tkinter/tklib )
+
+       local t
+       # all modules except tkinter output to .
+       # tkinter outputs to the correct dir ...
+       cd "${ED%/}${INSDESTTREE}"/lib_pypy || die
+       for t in "${cffi_targets[@]}"; do
+               # tkinter doesn't work via -m
+               "${PYTHON}" "_${t}_build.py" || die "Failed to build CFFI 
bindings for ${t}"
+       done
+
+       # Cleanup temporary objects
+       find "${ED%/}${INSDESTTREE}" -name "_cffi_*.[co]" -delete || die
+       find "${ED%/}${INSDESTTREE}" -type d -empty -delete || die
+
+       # compile the installed modules
+       python_optimize "${ED%/}${INSDESTTREE}"
+}

Reply via email to